diff -urN linux.store/linux/arch/arm/lib/traps.S linux/arch/arm/lib/traps.S
--- linux.store/linux/arch/arm/lib/traps.S	Sun Mar  3 13:18:51 1996
+++ linux/arch/arm/lib/traps.S	Thu Mar 28 10:32:04 1996
@@ -23,6 +23,8 @@
 
 #include <asm/assembler.h>
 #include <asm/errno.h>
+#include <asm/hardware.h>
+
 		.text
 
 @ Offsets into task structure
@@ -46,10 +48,6 @@
 #define BAD_ADDREXCPTN	2
 #define BAD_IRQ		3
 
-@ Address of start of IOC
-@
-#define IOC		0x03200000
-
 @ Number of syscalls accepted
 @
 #define NSYS_CALL	142
@@ -145,10 +143,10 @@
 		bic	r4, r4, #0xff000000		@ mask off swi op code
 		eor	r4, r4, #OS_NUMBER << 20	@ check OS number
 		tst	r4, #0x00f00000
-		bne	bad
-retry:		cmp	r4, #NSYS_CALL			@ check upper syscall limit
-		bcs	swi_bad_call
-		bl	_arm3_flushcache
+		bne	Lbad
+Lretry:		cmp	r4, #NSYS_CALL			@ check upper syscall limit
+		bcs	Lswi_bad_call
+		bl	_armcache_flush
 
 		ldr	r5, [pc, #LC1 - . - 8]
 		ldr	r5, [r5]
@@ -157,7 +155,7 @@
 
 		ldr	ip, [r5, #FLAGS]		@ check for syscall tracing
 		tst	ip, #PF_TRACESYS
-		bne	trace_this_syscall
+		bne	Ltrace_this_syscall
 
 		ldr	ip, [pc, #LC2 - . - 8]
 		mov	r9, sp				@ hack for routines needing > 4 values
@@ -168,10 +166,10 @@
 		rsbs	ip, ip, #0
 		movne	r0, ip
 		streq	r0, [sp, #0]			@ returned r0
-		bl	_arm3_flushcache
+		bl	_armcache_flush
 		b	_ret_from_sys_call
 
-trace_this_syscall:
+Ltrace_this_syscall:
 		ldr	r7, [sp, #S_IP]
 		mov	r0, #0
 		str	r0, [sp, #S_IP]
@@ -193,21 +191,21 @@
 		str	r0, [sp, #S_IP]
 		bl	_syscall_trace			@ trace exit [IP must != 0]
 		str	r7, [sp, #S_IP]
-		bl	_arm3_flushcache
+		bl	_armcache_flush
 		b	_ret_from_sys_call
 
 
-swi_bad_call:	cmp	r4, #(KSWI_SYS_BASE - KSWI_BASE)@ check for arm private syscalls
-		bcs	arm_sys_call
+Lswi_bad_call:	cmp	r4, #(KSWI_SYS_BASE - KSWI_BASE)@ check for arm private syscalls
+		bcs	Larm_sys_call
 		bl	_sys_ni_syscall
 		str	r0, [sp, #0]			@ returned r0
 		b	_ret_from_sys_call
 
-bad:		bl	_deferred
+Lbad:		bl	_deferred
 		ldmfd	sp, {r0 - r3}
-		b	retry
+		b	Lretry
 
-arm_sys_call:	bic	r0, r4, #0x000f0000
+Larm_sys_call:	bic	r0, r4, #0x000f0000
 		mov	r1, sp
 		bl	_arm_syscall
 		b	_ret_from_sys_call
@@ -368,7 +366,7 @@
 
 fiqmsg:		.ascii	"*** Unexpeced FIQ\n\0"
 
-_unexp_fiq:	mov	r12, #IOC
+_unexp_fiq:	mov	r12, #IOC_BASE
 		strb	r12, [r12, #0x38]	@ Disable FIQ register
 		teqp	pc, #0x0c000003
 		mov	r0, r0
@@ -383,7 +381,7 @@
 		.global	_trap_init
 _trap_init:	stmfd	sp !,{r4 - r9,lr}	@ Save link register
 		teqp	pc, #0x0c000003
-		mov	r0, #IOC
+		mov	r0, #IOC_BASE
 		str	r0, [r0, #0x18]
 		str	r0, [r0, #0x28]
 		str	r0, [r0, #0x38]
@@ -407,7 +405,7 @@
 		ldmfd	sp!, {r4 - r9, pc}^
 
 LC4:
-		.word	_irq_temp
+		.word	Lirq_temp
 LC5:
 		.word	_irqjump
 
@@ -426,7 +424,7 @@
 		ldr	lr, [pc, #LC4 - . - 8]
 		ldr	lr, [lr]
 		USER_SAVE_ALL
-urepeat:	mov	r4, #IOC			@ point at IOC
+urepeat:	mov	r4, #IOC_BASE		@ point at IOC
 		ldrb	r1, [r4, #0x24]		@ get high priority first
 		adr	r2, irq_prio_h
 		teq	r1, #0
@@ -458,7 +456,7 @@
                 and	r2, lr, #3
 		teq	r2, #3
 		bne	irq_illegal_mode
-srepeat:	mov	r4, #IOC		@ point at IOC
+srepeat:	mov	r4, #IOC_BASE		@ point at IOC
 		ldrb	r1, [r4, #0x24]		@ get high priority first
 		adr	r2, irq_prio_h
 		teq	r1, #0
@@ -582,14 +580,15 @@
 		tst	r5, #1<<20		@ Check to see if it is a write instruction
 		orreq	r2, r2, #0x20		@ Indicate write instruction
 		tst	r5, #1 << 26		@ Check LDMSTM/LDRSTRLDCSTC
-		bne	data_ldrstrldcstc	@ If set, then it is not LDMSTM
+		bne	Ldata_ldrstrldcstc	@ If set, then it is not LDMSTM
 
 		mov	r6, #1 << 15
 		mov	r7, #0
-data_ldmstm_cr:	tst	r5, r6			@ Check this register
+Ldata_ldmstm_cr:
+		tst	r5, r6			@ Check this register
 		addne	r7, r7, #4		@ If set, then another register
 		movs	r6, r6, lsr#1
-		bne	data_ldmstm_cr
+		bne	Ldata_ldmstm_cr
 		eor	r1, r5, r5, lsl#2
 		tst	r1, #1<<23		@ Check inc/dec bit ^ writeback
 		rsbeq	r7, r7, #0
@@ -608,22 +607,22 @@
 		orr	r2, r2, #0x200
 		b	_do_dataabort
 
-data_ldrstrldcstc:
+Ldata_ldrstrldcstc:
 		mov	r6, r5, lsr#(16-2)	@ Get Rn
 		and	r6, r6, #15*4		@ Mask out register
 		teq	r6, #15*4		@ CHECK FOR PC
 		ldr	r6, [r3, r6]		@ Get register
 		biceq	r6, r6, #0xfc000003
 		tst	r5, #1 << 24		@ Check index type bit
-		beq	ldrstrpost		@ Post indexing?
+		beq	Lldrstrpost		@ Post indexing?
 		tst	r5, #1 << 27		@ Get LDRSTR/LDCSTC bit
-		bne	instrldcstc		@ If set, do LDC/STC instruction
+		bne	Linstrldcstc		@ If set, do LDC/STC instruction
 		tst	r5, #1 << 25		@ Check immediate bit
-		bne	ldrstrregval		@ Register is specified
+		bne	Lldrstrregval		@ Register is specified
 		mov	r1, #0xff
 		orr	r1, r1, #0xf00
 		and	r7, r5, r1
-ldrstrsubadd:
+Lldrstrsubadd:
 		tst	r5, #1 << 23
 		addne	r1, r6, r7
 		movne	r0, r6
@@ -632,14 +631,14 @@
 		orr	r2, r2, #0x300
 		b	_do_dataabort
 
-ldrstrpost:	mov	r0, r6
+Lldrstrpost:	mov	r0, r6
 		mov	r1, r0			@ Set higher address same
 		tst	r5, #1 << 21
 		bicne	r2, r2, #3		@ If T bit is set, force user mode
 		orr	r2, r2, #0x400
 		b	_do_dataabort
 
-ldrstrregval:	and	r7, r5,#15
+Lldrstrregval:	and	r7, r5,#15
 		teq	r7, #15			@ CHECK FOR PC
 		ldr	r7, [r3, r7, lsl#2]	@ Get Rm
 		biceq	r7, r7, #0xfc000003
@@ -661,9 +660,9 @@
 		orr	r2, r2, #0x500
 		b	_do_dataabort
 
-instrldcstc:	and	r7, r5, #255		@ Get offset
+Linstrldcstc:	and	r7, r5, #255		@ Get offset
 		orr	r2, r2, #0x600
-		B	ldrstrsubadd
+		B	Lldrstrsubadd
 
 @ ===============================================================================
 @
@@ -678,20 +677,20 @@
 		.word	_current		@ +8
 		.word	_init_task		@ +12
 
-reschedule:	bl	_schedule
+Lreschedule:	bl	_schedule
 
 _ret_from_sys_call:
 		ldr	r4, [pc, #LC6 - . - 8]
 		ldr	r5, [r4]
 		teq	r5, #0
-		bne	ret_no_check
+		bne	Lret_no_check
 		ldr	r6, [pc, #LC6 - . - 4]
 		ldr	r7, [pc, #LC6 - . - 0]
-recheck_bh:	ldr	r0, [r6]
+Lrecheck_bh:	ldr	r0, [r6]
 		ldr	r1, [r7]
 		tst	r0, r1
-		beq	no_handle_bh
-handle_bottom_half:
+		beq	Lno_handle_bh
+Lhandle_bottom_half:
 		add	r0, r5, #1
 		str	r0, [r4]
 		mov	r8, pc
@@ -699,32 +698,32 @@
 		bl	_do_bottom_half
 		teqp	r8, #0
 		str	r5, [r4]
-		b	recheck_bh
-no_handle_bh:	teqp	pc, #0x00000003
+		b	Lrecheck_bh
+Lno_handle_bh:	teqp	pc, #0x00000003
 		ldr	r0, [pc, #LC6 - . + 4]
 		ldr	r0, [r0]
 		teq	r0, #0
-		bne	reschedule
+		bne	Lreschedule
 		ldr	r4, [pc, #LC6 - . + 8]
 		ldr	r4, [r4]
 		ldr	r0, [pc, #LC6 - . + 12]
 		teq	r4, r0
-		beq	ret_no_check
+		beq	Lret_no_check
 		ldr	r0, [r4, #STATE]
 		teq	r0, #0
-		bne	reschedule
+		bne	Lreschedule
 		ldr	r0, [r4, #COUNTER]
 		teq	r0, #0
-		beq	reschedule
+		beq	Lreschedule
 		ldr	r1, [r4, #SIGNAL]
 		ldr	r0, [r4, #BLOCKED]
 		bics	r1, r1, r0
 		movne	r1, sp
 		blne	_do_signal
-ret_no_check:	USER_RESTORE_ALL
+Lret_no_check:	USER_RESTORE_ALL
 
-		.global	_arm3_flushcache
-_arm3_flushcache:
+		.global	_armcache_flush
+_armcache_flush:
 		mcr	15, 0, r0, c1, c0	@ flush cache
 		movs	pc, lr
 
@@ -737,5 +736,5 @@
 _fp_save:	.word	_fpnull
 _fp_restore:	.word	_fpnull
 
-_irq_temp:	.word	0
+Lirq_temp:	.word	0
 
diff -urN linux.store/linux/changed linux/changed
--- linux.store/linux/changed	Thu Jan  1 01:00:00 1970
+++ linux/changed	Thu Mar 28 15:08:28 1996
@@ -0,0 +1,12 @@
+./arch/arm/drivers/block/fd1772.c.orig
+./arch/arm/drivers/block/hdsrch.c.orig
+./arch/arm/drivers/block/mfmhd.c.orig
+./arch/arm/drivers/block/blk.h.orig
+./arch/arm/drivers/char/console.c.orig
+./arch/arm/kernel/oldlatches.c.orig
+./arch/arm/kernel/dma.c.orig
+./arch/arm/lib/mfm.S.orig
+./arch/arm/lib/Makefile.orig
+./include/asm-arm/arch-arc/oldlatches.h.orig
+./include/asm-arm/arch-arc/system.h.orig
+./README.arm.orig
diff -urN linux.store/linux/drivers/char/conmakehash.c linux/drivers/char/conmakehash.c
--- linux.store/linux/drivers/char/conmakehash.c	Sat Feb 10 23:28:16 1996
+++ linux/drivers/char/conmakehash.c	Thu Mar 28 14:17:04 1996
@@ -286,7 +286,7 @@
          }
        printf("0x%04x", unitable[fp0][nent++]);
        if ( i == nuni-1 )
-         printf("\n};");
+         printf("\n};\n");
        else if ( i % 8 == 7 )
          printf(",\n\t");
        else
diff -urN linux.store/linux/include/asm-arm/arch-a5k/hardware.h linux/include/asm-arm/arch-a5k/hardware.h
--- linux.store/linux/include/asm-arm/arch-a5k/hardware.h	Thu Jan  1 01:00:00 1970
+++ linux/include/asm-arm/arch-a5k/hardware.h	Fri Mar 22 23:44:12 1996
@@ -0,0 +1,57 @@
+/*
+ * linux/include/asm-arm/arch-a5k/hardware.h
+ *
+ * Copyright (C) 1996 Russell King.
+ *
+ * This file contains the hardware definitions of the A5000 series machines.
+ */
+
+#ifndef __ASM_ARCH_HARDWARE_H
+#define __ASM_ARCH_HARDWARE_H
+
+/*
+ * What hardware must be present
+ */
+#define HAS_IOC
+#define HAS_PCIO
+#define HAS_MEMC1A
+/*
+ * Optional hardware
+ */
+#define HAS_EXPMASK
+
+#ifndef __ASSEMBLER__
+
+/*
+ * IO definitions
+ */
+#define IOCECIO_BASE		0x03240000
+#define EXPMASK_BASE		((volatile unsigned char *)0x03360000)
+#define IOEB_BASE		((volatile unsigned char *)0x03350050)
+#define IOC_BASE		((volatile unsigned char *)0x03200000)
+#define PCIO_FLOPPYDMABASE	((volatile unsigned char *)0x0302a000)
+#define PCIO_BASE		((volatile unsigned char *)0x03010000)
+#define MEMCECIO_BASE		0x03000000
+
+#else
+
+#define IOEB_BASE		0x03350050
+#define IOC_BASE		0x03200000
+#define PCIO_FLOPPYDMABASE	0x0302a000
+#define PCIO_BASE		0x03010000
+
+#endif
+
+/*
+ * RAM definitions
+ */
+#define GET_MEMORY_PHYSICAL	(0x02000000)
+#define GET_MEMORY_START	((unsigned long)&_end - 0x01800000 + KERNEL_BASE)
+#define GET_MEMORY_END(ps,np)	(GET_MEMORY_PHYSICAL + (ps) * (np))
+
+#define SCREEN_BASE		GET_MEMORY_PHYSICAL
+#define PARAMS_BASE		(GET_MEMORY_PHYSICAL + 0x7c000)
+#define KERNEL_BASE		(GET_MEMORY_PHYSICAL + 0x80000)
+
+#endif
+
diff -urN linux.store/linux/include/asm-arm/arch-a5k/shmparam.h linux/include/asm-arm/arch-a5k/shmparam.h
--- linux.store/linux/include/asm-arm/arch-a5k/shmparam.h	Thu Jan  1 01:00:00 1970
+++ linux/include/asm-arm/arch-a5k/shmparam.h	Thu Mar 28 11:30:58 1996
@@ -0,0 +1,5 @@
+/*
+ * linux/include/asm-arm/arch-a5k/shmparam.h
+ *
+ * Copyright (c) 1996 Russell King.
+ */
diff -urN linux.store/linux/include/asm-arm/arch-a5k/system.h linux/include/asm-arm/arch-a5k/system.h
--- linux.store/linux/include/asm-arm/arch-a5k/system.h	Thu Jan  1 01:00:00 1970
+++ linux/include/asm-arm/arch-a5k/system.h	Thu Mar 28 11:31:27 1996
@@ -0,0 +1,6 @@
+/*
+ * linux/include/asm-arm/arch-a5k/system.h
+ *
+ * Copyright (c) 1996 Russell King
+ */
+
diff -urN linux.store/linux/include/asm-arm/arch-arc/hardware.h linux/include/asm-arm/arch-arc/hardware.h
--- linux.store/linux/include/asm-arm/arch-arc/hardware.h	Thu Jan  1 01:00:00 1970
+++ linux/include/asm-arm/arch-arc/hardware.h	Fri Mar 22 22:32:41 1996
@@ -0,0 +1,47 @@
+/*
+ * linux/include/asm-arm/arch-a5k/hardware.h
+ *
+ * Copyright (C) 1996 Russell King.
+ *
+ * This file contains the hardware definitions of the A5000 series machines.
+ */
+
+#ifndef __ASM_ARCH_HARDWARE_H
+#define __ASM_ARCH_HARDWARE_H
+
+#define HAS_IOC
+#define HAS_MEMC1A
+#define HAS_PCIO
+
+#ifndef ASSEMBLER
+
+/*
+ * IO definitions
+ */
+#define IOEB_BASE		((volatile unsigned char *)0x03350050)
+#define IOC_BASE		((volatile unsigned char *)0x03200000)
+#define PCIO_FLOPPYDMABASE	((volatile unsigned char *)0x0302a000)
+#define PCIO_BASE		((volatile unsigned char *)0x03010000)
+
+#else
+
+#define IOEB_BASE		0x03350050
+#define IOC_BASE		0x03200000
+#define PCIO_FLOPPYDMABASE	0x0302a000
+#define PCIO_BASE		0x03010000
+
+#endif
+
+/*
+ * RAM definitions
+ */
+#define GET_MEMORY_PHYSICAL	(0x02000000)
+#define GET_MEMORY_START	((unsigned long)&_end - 0x01800000 + KERNEL_BASE)
+#define GET_MEMORY_END(ps,np)	(GET_MEMORY_PHYSICAL + (ps) * (np))
+
+#define SCREEN_BASE		GET_MEMORY_PHYSICAL
+#define PARAMS_BASE		(GET_MEMORY_PHYSICAL + 0x7c000)
+#define KERNEL_BASE		(GET_MEMORY_PHYSICAL + 0x80000)
+
+#endif
+
diff -urN linux.store/linux/include/asm-arm/arch-arc/oldlatches.h linux/include/asm-arm/arch-arc/oldlatches.h
--- linux.store/linux/include/asm-arm/arch-arc/oldlatches.h	Wed Mar 13 23:55:11 1996
+++ linux/include/asm-arm/arch-arc/oldlatches.h	Thu Mar 28 14:24:56 1996
@@ -1,5 +1,5 @@
 #ifndef _ASM_ARM_ARCHARC_OLDLATCH_H
-#define _ASN_ARM_ARCHARC_OLDLATCH_H
+#define _ASM_ARM_ARCHARC_OLDLATCH_H
 
 #define LATCHA_FDSEL0    (1<<0)
 #define LATCHA_FDSEL1    (1<<1)
diff -urN linux.store/linux/include/asm-arm/arch-arc/shmparam.h linux/include/asm-arm/arch-arc/shmparam.h
--- linux.store/linux/include/asm-arm/arch-arc/shmparam.h	Thu Jan  1 01:00:00 1970
+++ linux/include/asm-arm/arch-arc/shmparam.h	Thu Mar 28 11:45:19 1996
@@ -0,0 +1,5 @@
+/*
+ * linux/include/asm-arm/arch-arc/shmparam.h
+ *
+ * Copyright (c) 1996 Russell King.
+ */
diff -urN linux.store/linux/include/asm-arm/arch-arc/system.h linux/include/asm-arm/arch-arc/system.h
--- linux.store/linux/include/asm-arm/arch-arc/system.h	Wed Mar 13 23:55:11 1996
+++ linux/include/asm-arm/arch-arc/system.h	Thu Mar 28 14:24:56 1996
@@ -5,5 +5,7 @@
 "	mov	%0, pc\n"		\
 "	orr %0, %0, #0x0c000000\n"	\
 "	teqp	%0, #0\n"		\
-	  : "=r" (temp));
+	  : "=r" (temp)	\
+    : );	\
+  } while(0)
 
diff -urN linux.store/linux/include/asm-arm/arch-rpc/system.h linux/include/asm-arm/arch-rpc/system.h
--- linux.store/linux/include/asm-arm/arch-rpc/system.h	Thu Jan  1 01:00:00 1970
+++ linux/include/asm-arm/arch-rpc/system.h	Thu Mar 28 11:45:43 1996
@@ -0,0 +1,5 @@
+/*
+ * linux/include/asm-arm/arch-rpc/system.h
+ *
+ * Copyright (c) 1996 Russell King.
+ */
diff -urN linux.store/linux/include/asm-arm/ecard.h linux/include/asm-arm/ecard.h
--- linux.store/linux/include/asm-arm/ecard.h	Sun Feb 11 09:32:54 1996
+++ linux/include/asm-arm/ecard.h	Fri Mar 22 23:20:03 1996
@@ -64,7 +64,7 @@
 	struct ex_ecld ecld;
 	unsigned char irq;
 	unsigned char fiq;
-	unsigned char unused1;
+	unsigned char slot_no;
 	unsigned char unused2;
 	unsigned char *r_loader; /* loader program */
 	volatile unsigned char *r_podaddr;
@@ -97,3 +97,12 @@
  * num: (n+1)'th id to find.
  */
 extern int ecard_readchunk(struct chunk_dir *cd, struct expansion_card *ec, int id, int num);
+
+/*
+ * Obtain the address of a card
+ */
+#define ECARD_SLOW	0
+#define ECARD_MEDIUM	1
+#define ECARD_FAST	2
+#define ECARD_SYNC	3
+extern unsigned char *ecard_address (int card, int memc, int speed);
diff -urN linux.store/linux/include/asm-arm/hardware.h linux/include/asm-arm/hardware.h
--- linux.store/linux/include/asm-arm/hardware.h	Thu Jan  1 01:00:00 1970
+++ linux/include/asm-arm/hardware.h	Fri Mar 22 23:01:27 1996
@@ -0,0 +1,85 @@
+/*
+ * linux/include/asm-arm/hardware.h
+ *
+ * Copyright (C) 1996 Russell King
+ *
+ * Common hardware definitions
+ */
+
+#ifndef __ASM_HARDWARE_H
+#define __ASM_HARDWARE_H
+
+#include <asm/arch/hardware.h>
+#include <asm/proc/hardware.h>
+
+/*
+ * Use these macros to read/write the IOC.  All it does is perform the actual
+ * read/write.
+ */
+#ifdef HAS_IOC
+#ifndef ASSEMBER
+#define __IOC(offset)	(((volatile unsigned char *)IOC_BASE)[offset])
+#else
+#define __IOC(offset)	offset
+#endif
+
+#define IOC_CONTROL	__IOC(0x00)
+#define IOC_KARTTX	__IOC(0x04)
+#define IOC_KARTRX	__IOC(0x04)
+
+#define IOC_IRQSTATA	__IOC(0x10)
+#define IOC_IRQREQA	__IOC(0x14)
+#define IOC_IRQCLRA	__IOC(0x14)
+#define IOC_IRQMASKA	__IOC(0x18)
+
+#define IOC_IRQSTATB	__IOC(0x20)
+#define IOC_IRQREQB	__IOC(0x24)
+#define IOC_IRQMASKB	__IOC(0x28)
+
+#define IOC_FIQSTAT	__IOC(0x30)
+#define IOC_FIQREQ	__IOC(0x34)
+#define IOC_FIQMASK	__IOC(0x38)
+
+#define IOC_T0CNTL	__IOC(0x40)
+#define IOC_T0LTCHL	__IOC(0x40)
+#define IOC_T0CNTH	__IOC(0x44)
+#define IOC_T0LTCHH	__IOC(0x44)
+#define IOC_T0GO	__IOC(0x48)
+#define IOC_T0LATCH	__IOC(0x4c)
+
+#define IOC_T1CNTL	__IOC(0x50)
+#define IOC_T1LTCHL	__IOC(0x50)
+#define IOC_T1CNTH	__IOC(0x54)
+#define IOC_T1LTCHH	__IOC(0x54)
+#define IOC_T1GO	__IOC(0x58)
+#define IOC_T1LATCH	__IOC(0x5c)
+
+#define IOC_T2CNTL	__IOC(0x60)
+#define IOC_T2LTCHL	__IOC(0x60)
+#define IOC_T2CNTH	__IOC(0x64)
+#define IOC_T2LTCHH	__IOC(0x64)
+#define IOC_T2GO	__IOC(0x68)
+#define IOC_T2LATCH	__IOC(0x6c)
+
+#define IOC_T3CNTL	__IOC(0x70)
+#define IOC_T3LTCHL	__IOC(0x70)
+#define IOC_T3CNTH	__IOC(0x74)
+#define IOC_T3LTCHH	__IOC(0x74)
+#define IOC_T3GO	__IOC(0x78)
+#define IOC_T3LATCH	__IOC(0x7c)
+
+#endif
+
+#ifdef HAS_EXPMASK
+#ifndef ASSEMBER
+#define __EXPMASK(offset)	(((volatile unsigned char *)EXPMASK_BASE)[offset])
+#else
+#define __EXPMASK(offset)	offset
+#endif
+
+#define	EXPMASK_STATUS	__EXPMASK(0x00)
+#define EXPMASK_ENABLE	__EXPMASK(0x04)
+
+#endif
+
+#endif
diff -urN linux.store/linux/include/asm-arm/proc-arm2/hardware.h linux/include/asm-arm/proc-arm2/hardware.h
--- linux.store/linux/include/asm-arm/proc-arm2/hardware.h	Thu Jan  1 01:00:00 1970
+++ linux/include/asm-arm/proc-arm2/hardware.h	Fri Mar 22 22:39:08 1996
@@ -0,0 +1,15 @@
+/*
+ * linux/include/asm-arm/proc-arm2/hardware.h
+ *
+ * Copyright (C) 1996 Russell King
+ */
+
+#ifndef __ASM_PROC_HARDWARE_H
+#define __ASM_PROC_HARDWARE_H
+
+/*
+ * No cache setup required
+ */
+#define cache_setup(x)
+
+#endif
diff -urN linux.store/linux/include/asm-arm/proc-arm250/assembler.h linux/include/asm-arm/proc-arm250/assembler.h
--- linux.store/linux/include/asm-arm/proc-arm250/assembler.h	Thu Jan  1 01:00:00 1970
+++ linux/include/asm-arm/proc-arm250/assembler.h	Sun Feb 11 09:32:54 1996
@@ -0,0 +1,52 @@
+/*
+ * linux/asm-arm/proc-arm3/assembler.h
+ *
+ * This file contains arm architecture specific defines
+ * for the different processors
+ */
+
+/*
+ * LOADREGS: multiple register load (ldm) with pc in register list
+ *		(takes account of ARM6 not using ^)
+ *
+ * RETINSTR: return instruction: adds the 's' in at the end of the
+ *		instruction if this is not an ARM6
+ *
+ * SAVEIRQS: save IRQ state (not required on ARM2/ARM3 - done
+ *		implicitly
+ *
+ * RESTOREIRQS: restore IRQ state (not required on ARM2/ARM3 - done
+ *		implicitly with ldm ... ^ or movs.
+ *
+ * These next two need thinking about - can't easily use stack... (see system.S)
+ * DISABLEIRQS: disable IRQS in SVC mode
+ *
+ * ENABLEIRQS: enable IRQS in SVC mode
+ *
+ * USERMODE: switch to USER mode
+ *
+ * SVCMODE: switch to SVC mode
+ */
+
+#define LOADREGS(cond, base, reglist...)\
+	ldm##cond	base,reglist^
+
+#define RETINSTR(instr, regs...)\
+	instr##s	regs
+
+#define MODENOP
+
+#define SAVEIRQS
+#define RESTOREIRQS
+
+#define DISABLEIRQS\
+	teqp	pc, #0x08000003
+
+#define ENABLEIRQS\
+	teqp	pc, #0x00000003
+
+#define USERMODE\
+	teqp	pc, #0x00000000
+
+#define SVCMODE\
+	teqp	pc, #0x00000003
diff -urN linux.store/linux/include/asm-arm/proc-arm250/bugs.h linux/include/asm-arm/proc-arm250/bugs.h
--- linux.store/linux/include/asm-arm/proc-arm250/bugs.h	Thu Jan  1 01:00:00 1970
+++ linux/include/asm-arm/proc-arm250/bugs.h	Sun Feb 11 09:32:54 1996
@@ -0,0 +1,17 @@
+/*
+ *  include/asm-arm/bugs.h
+ *
+ *  Copyright (C) 1995  Russell King
+ */
+
+/*
+ * This is included by init/main.c to check for architecture-dependent bugs.
+ *
+ * Needs:
+ *      void check_bugs(void);
+ */
+         
+static inline void check_bugs(void)
+{
+}
+
diff -urN linux.store/linux/include/asm-arm/proc-arm250/hardware.h linux/include/asm-arm/proc-arm250/hardware.h
--- linux.store/linux/include/asm-arm/proc-arm250/hardware.h	Thu Jan  1 01:00:00 1970
+++ linux/include/asm-arm/proc-arm250/hardware.h	Fri Mar 22 23:43:01 1996
@@ -0,0 +1,36 @@
+/*
+ * linux/include/asm-arm/proc-arm3/hardware.h
+ *
+ * Copyright (C) 1996 Russell King
+ */
+
+#ifndef __ASM_PROC_HARDWARE_H
+#define __ASM_PROC_HARDWARE_H
+
+#include <asm/procinfo.h>
+
+#ifndef __ASSEMBLER__
+/*
+ * Need to setup cache on ARM3, but not the ARM250
+ */
+extern __inline__ void cache_setup (int features)
+{
+    if (features & F_CACHE) {
+	__asm__ __volatile__("
+	mcr	15, 0, %0, c3, c0
+	mcr	15, 0, %1, c4, c0
+	mcr	15, 0, %2, c5, c0
+	mcr	15, 0, %3, c1, c0
+	mcr	15, 0, %3, c2, c0
+	" : : "r" (0x000e7fff), "r" (0x000e7fff), "r" (0xf0000000), "r" (3));
+    } else {
+    	extern unsigned long armcache_flush[2];
+
+    	armcache_flush[0] = armcache_flush[1];
+    }
+}
+
+#endif
+
+#endif
+
diff -urN linux.store/linux/include/asm-arm/proc-arm250/page.h linux/include/asm-arm/proc-arm250/page.h
--- linux.store/linux/include/asm-arm/proc-arm250/page.h	Thu Jan  1 01:00:00 1970
+++ linux/include/asm-arm/proc-arm250/page.h	Wed Mar 13 22:26:56 1996
@@ -0,0 +1,105 @@
+/*
+ * linux/include/asm-arm/proc-arm3/page.h
+ *
+ * Copyright (C) 1995, 1996 Russell King
+ */
+
+#ifndef __ASM_PROC_PAGE_H
+#define __ASM_PROC_PAGE_H
+
+#include <linux/config.h>
+
+/* PAGE_SHIFT determines the page size */
+#define PAGE_SHIFT	15
+
+#define LOGICAL_END	0x02000000
+
+#define PAGE_SIZE       (1UL << PAGE_SHIFT)
+#define PAGE_MASK       (~(PAGE_SIZE-1))
+
+#ifdef __KERNEL__
+
+#define CONFIG_STRICT_MM_TYPECHECKS
+
+#ifdef CONFIG_STRICT_MM_TYPECHECKS
+/*
+ * These are used to make use of C type-checking..
+ */
+typedef struct { unsigned long pte; } pte_t;
+typedef struct { unsigned long pmd; } pmd_t;
+typedef struct { unsigned long pgd; } pgd_t;
+typedef struct { unsigned long pgprot; } pgprot_t;
+
+#define pte_val(x)      ((x).pte)
+#define pmd_val(x)      ((x).pmd)
+#define pgd_val(x)      ((x).pgd)
+#define pgprot_val(x)   ((x).pgprot)
+
+#define __pte(x)        ((pte_t) { (x) } )
+#define __pmd(x)        ((pmd_t) { (x) } )
+#define __pgd(x)        ((pgd_t) { (x) } )
+#define __pgprot(x)     ((pgprot_t) { (x) } )
+
+#else
+/*
+ * .. while these make it easier on the compiler
+ */
+typedef unsigned long pte_t;
+typedef unsigned long pmd_t;
+typedef unsigned long pgd_t;
+typedef unsigned long pgprot_t;
+
+#define pte_val(x)      (x)
+#define pmd_val(x)      (x)
+#define pgd_val(x)      (x)
+#define pgprot_val(x)   (x)
+
+#define __pte(x)        (x)
+#define __pmd(x)        (x)
+#define __pgd(x)        (x)
+#define __pgprot(x)     (x)
+
+#endif
+
+extern void remap_task (pgd_t *);
+
+/*
+ * TLB invalidation:
+ *
+ *  - invalidate() invalidates the current task TLBs
+ *  - invalidate_all() invalidates all processes TLBs
+ *  - invalidate_task(task) invalidates the specified tasks TLB's
+ *  - invalidate_page(task, vmaddr) invalidates one page
+ */
+#define invalidate() \
+	remap_task(current->mm->pgd)
+#define invalidate_all() invalidate()
+#define invalidate_task(task) \
+do { if ((task)->mm == current->mm) invalidate(); } while (0)
+#define invalidate_page(task,addr) \
+do { if ((task)->mm == current->mm) invalidate(); } while (0)
+
+/* Certain architectures need to do special things when pte's
+ * within a page table are directly modified.  Thus, the following
+ * hook is made available.
+ */
+#define set_pte(pteptr, pteval) ((*(pteptr)) = (pteval))
+
+/* to align the pointer to the (next) page boundary */
+#define PAGE_ALIGN(addr)	(((addr)+PAGE_SIZE-1)&PAGE_MASK)
+
+/* This handles the memory map.. */
+#define PAGE_OFFSET		0x02000000
+#define MAP_NR(addr)		(((unsigned long)(addr) - PAGE_OFFSET) >> PAGE_SHIFT)
+
+typedef struct {
+	unsigned count:24,
+		 age:6,
+		 dirty:1,
+		 reserved:1;
+} mem_map_t;
+
+#endif /* __KERNEL__ */
+
+#endif /* __ASM_PROC_PAGE_H */
+
diff -urN linux.store/linux/include/asm-arm/proc-arm250/param.h linux/include/asm-arm/proc-arm250/param.h
--- linux.store/linux/include/asm-arm/proc-arm250/param.h	Thu Jan  1 01:00:00 1970
+++ linux/include/asm-arm/proc-arm250/param.h	Sun Feb 11 09:32:54 1996
@@ -0,0 +1,27 @@
+/*
+ * linux/include/asm-arm/proc-arm3/param.h
+ *
+ * Copyright (C) 1995, 1996 Russell King
+ */
+
+#ifndef __ASM_PROC_PARAM_H
+#define __ASM_PROC_PARAM_H
+
+#ifndef HZ
+#define HZ 100
+#endif
+
+#define EXEC_PAGESIZE   32768
+
+#ifndef NGROUPS
+#define NGROUPS         32
+#endif
+
+#ifndef NOGROUP
+#define NOGROUP         (-1)
+#endif
+
+#define MAXHOSTNAMELEN  64      /* max length of hostname */
+
+#endif
+
